module OLED_Refresh(
	sys_clk,
	rst_n,
	refresh_req,
	write_done,
	refresh_finish,
	refresh_data);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input rst_n;
	input refresh_req;
	input write_done;
	output refresh_finish;
	output [23:0] refresh_data;

	wire sys_clk;
	wire rst_n;
	wire refresh_req;
	wire write_done;
	wire refresh_finish;
	wire [23:0] refresh_data;

	//----Code starts here: integrated by Robei-----
	reg[23:0]	refresh_data_reg;
	reg[10:0]	refresh_index;
	reg[2:0]		page;
	assign refresh_data = refresh_data_reg;
	assign refresh_finish = (page == 'd7 && refresh_index == 'd130 && write_done == 1'b1) ? 1'b1 : 1'b0;
	
	always@(posedge sys_clk or negedge rst_n)
	begin
		if(rst_n == 1'b0)
			refresh_index <= 'd0;
		else if(refresh_index == 'd130 && write_done == 1'b1)
			refresh_index <= 'd0;
		else if(write_done == 1'b1)
			refresh_index <= refresh_index + 1'b1;
		else
			refresh_index <= refresh_index;
	end
	
	
	always@(posedge sys_clk or negedge rst_n)
	begin
		if(rst_n == 1'b0)
			page <= 'd0;
		else if(refresh_index == 'd130 && write_done == 1'b1)
			page <= page + 1'b1;
		else
			page <= page;
	end
	
	
	always@(*)
	begin
		case(refresh_index)
		'd0:  refresh_data_reg <= {8'h78,8'h00,8'hB0 + page};
		'd1:  refresh_data_reg <= {8'h78,8'h00,8'h00};
		'd2:  refresh_data_reg <= {8'h78,8'h00,8'h10};
		default: refresh_data_reg <= {8'h78,8'h40,8'h00};
		endcase
	end
	
	
	
	
endmodule    //OLED_Refresh

