module OLED_Top(
	sys_clk,
	rst_n,
	dht11_done,
	tempH,
	tempL,
	humidityH,
	humidityL,
	OLED_SCL,
	OLED_SDA);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input rst_n;
	input dht11_done;
	input [7:0] tempH;
	input [7:0] tempL;
	input [7:0] humidityH;
	input [7:0] humidityL;
	output OLED_SCL;
	inout OLED_SDA;

	wire sys_clk;
	wire rst_n;
	wire dht11_done;
	wire [7:0] tempH;
	wire [7:0] tempL;
	wire [7:0] humidityH;
	wire [7:0] humidityL;
	wire OLED_SCL;
	wire OLED_SDA;

	//----Code starts here: integrated by Robei-----
	localparam	OLED_INIT 		=  'd0;			//ʼ
	localparam	OLED_Refresh	=  'd1;			//ˢ£oledȫд0
	localparam  OLED_ShowFont	=	'd2;			//ʾַ
	localparam	OLED_IDLE 		=  'd3;			//
	localparam	OLED_ShowData	=	'd4;			//ʾ
	
	
	
	
	reg[4:0]	state , next_state;
	
	//IICź
	wire			IICWriteReq;
	wire[23:0]  IICWriteData;
	wire			IICWriteDone;
	
	//ʼź
	wire			init_finish;
	wire[23:0]  Init_data;
	wire 			init_req;
	
	//refreshź
	wire			refresh_finish;
	wire[23:0]	refresh_data;
	wire		   refresh_req;
	
	
	//ַʾź
	wire			showfont_finish;
	wire[23:0]	showfont_data;
	wire			showfont_req;
	
	
	//ʾź
	wire			showdata_finish;
	wire[23:0]	showdata_data;
	wire			showdata_req;
	
	assign init_req     = (state == OLED_INIT)     ? 1'b1 : 1'b0;
	
	assign refresh_req  = (state == OLED_Refresh)  ? 1'b1 : 1'b0;
	
	assign showfont_req = (state == OLED_ShowFont) ? 1'b1 : 1'b0;
	
	assign showdata_req = (state == OLED_ShowData) ? 1'b1 : 1'b0;
	
	always@(posedge sys_clk or negedge rst_n)
	begin
		if(rst_n == 1'b0)
			state <= OLED_INIT;
		else
			state <= next_state;
	end
	
	always@(*)
	begin
		case(state)
		OLED_INIT:
			if(init_finish == 1'b1)
				next_state <= OLED_Refresh;
			else
				next_state <= OLED_INIT;
		OLED_Refresh:
			if(refresh_finish == 1'b1)
				next_state <= OLED_ShowFont;
			else
				next_state <= OLED_Refresh;
		OLED_ShowFont:
			if(showfont_finish == 1'b1)
				next_state <= OLED_IDLE;
			else
				next_state <= OLED_ShowFont;
		OLED_IDLE:
			if(dht11_done == 1'b1)
				next_state <= OLED_ShowData;
			else
				next_state <= OLED_IDLE;
		OLED_ShowData:
			if(showdata_finish == 1'b1)
				next_state <= OLED_IDLE;
			else
				next_state <= OLED_ShowData;
		default: next_state <= OLED_INIT;
		endcase
	end
	
	
	
	
	
	
	
	
	
	
	
	
	
	//---Module instantiation---
	OLED_Init OLED_Init1(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.init_req(init_req),
		.init_finish(init_finish),
		.Init_data(Init_data));

	OLED_Refresh OLED_Refresh2(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.refresh_req(refresh_req),
		.refresh_finish(refresh_finish),
		.refresh_data(refresh_data));

	OLED_ShowFont OLED_ShowFont3(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.ShowFont_req(showfont_req),
		.ShowFont_Data(showfont_data),
		.ShowFont_finish(showfont_finish));

	OLED_ShowData OLED_ShowData4(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.dht11_done(dht11_done),
		.tempH(tempH),
		.tempL(tempL),
		.humidityH(humidityH),
		.humidityL(humidityL),
		.ShowData_req(showdata_req),
		.ShowData_Data(showdata_data),
		.ShowData_finish (showdata_finish));

	OLED_SelData OLED_SelData5(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.init_req(init_req),
		.init_data(Init_data),
		.refresh_req(refresh_req),
		.refresh_data(refresh_data),
		.showfont_req(showfont_req),
		.showfont_data(showfont_data),
		.showdata_req(showdata_req),
		.showdata_data(showdata_data),
		.IICWriteReq(IICWriteReq),
		.IICWriteData(IICWriteData));

	iic2 iic27(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.IICSlave({IICWriteData[15:8],IICWriteData[23:16]}),
		.IICWriteReq(IICWriteReq),
		.IICWriteData(IICWriteData[7:0]),
		.IICReadReq(1'b0),
		.IICSCL(OLED_SCL),
		.IICWriteDone(IICWriteDone),
		.IICSDA(OLED_SDA));

endmodule    //OLED_Top

