module ble_ctrl(
	clk,
	rstn,
	ble_rxd,
	rdata,
	rx_sig);

	//---Ports declearation: generated by Robei---
	input clk;
	input rstn;
	input ble_rxd;
	output [7:0] rdata;
	output rx_sig;

	wire clk;
	wire rstn;
	wire ble_rxd;
	reg [7:0] rdata;
	reg rx_sig;

	//----Code starts here: integrated by Robei-----
	//ͨŲʲѡ
	parameter      	CNT_BAUD9600 	= 1735,
					CNT_BAUD19200 	= 867,
					CNT_BAUD38400 	= 433,
					CNT_BAUD57600 	= 288,
					CNT_BAUD115200 	= 143;
	//				CNT_BAUD115200 	= 4;
	//ͨŲʲ
	parameter	CNT_END_SEL = CNT_BAUD115200;	
	
	//////////////////////////////////////////////
	/////////////ʱģ///////////////
	///////ֵʱ ////////
	///////ۼ                 ////////
	///////ʱֵʱת   ////////
	//////////////////////////////////////////////
	reg baud_clk;			//(*mark_debug = "true"*)
	reg [11:0] baud_cnt;
	//baud clock generate
	always@(posedge clk or negedge rstn)
	begin
		if(!rstn)begin
			baud_clk <= 1'b0;
			baud_cnt <= 12'd0;
		end
		else if (baud_cnt == CNT_END_SEL)
		begin
			baud_clk <= ~baud_clk;
			baud_cnt <= 12'd0;
		end
		else 
		begin
			baud_cnt <= baud_cnt + 1'b1;
		end
	end
	//״̬״̬
	parameter 	IDLE 		= 2'd0,
				READY		= 2'd1,
				RX_DATA 	= 2'd2,
				RX_FINISH 	= 2'd3;
	//һʽ״̬ڽ8bit
	reg	[1:0] 	state;
	reg [2:0]	rx_cnt;
	reg [7:0]	rx_reg;			//(*mark_debug = "true"*)
	always@(posedge baud_clk or negedge rstn)
	begin
		if(!rstn)
		begin
			rdata <= 8'd0;
			rx_reg <= 8'd0;
			rx_cnt <= 3'd0;
			rx_sig <= 1'b0;
			state <= IDLE;
		end
		else
			case(state)
				IDLE:                    //״̬״̬ʼ
				begin
					rdata <= 8'd0;
					rx_reg <= 8'd0;
					rx_sig <= 1'b0;
					rx_cnt <= 3'd0;
					state <= READY;
				end
				READY:                   //׼ʼλ״̬
				begin
					rx_reg <= 8'd0;
					rx_sig <= 1'b0;
					rx_cnt <= 3'd0;
					if(!ble_rxd)        //⵽ź1Ϊ0ʱʼ
						state <= RX_DATA;
					else
						state <= READY;
					end
				RX_DATA:                //8bit
				begin
					if(rx_cnt==7)       //8bitݺתսλ״̬
					begin
						rx_reg[rx_cnt] <= ble_rxd;
						rx_sig <= 1'b1;
						state <= RX_FINISH;
					end
					else
					begin               //ǰ7bitʱյݴ洢ڼĴrx_regĵ0λ
						rx_reg[rx_cnt] <= ble_rxd;//յδ洢rx_regĵ1234567λ
						rx_cnt <= rx_cnt + 1'b1;  //ݼÿ1bitݺۼ
						state <= RX_DATA; //ǰ7bitʱһ״̬ȻΪǰ״̬
					end
				end
				RX_FINISH:               //սλ״̬
				begin
					rdata <= rx_reg;
					rx_sig <= 1'b1;
					if(ble_rxd)     //¼⵽ߵƽʼһλ
						state <= READY;
					else            //߼⵽͵ƽݴֹͣ
						state <= RX_FINISH;
				end
				default:
				begin
					rdata <= 8'd0;
					rx_reg <= 8'd0;
					rx_sig <= 1'b0;
					rx_cnt <= 3'd0;
					state <= IDLE;
				end
			endcase
		end
	
	
	
endmodule    //ble_ctrl

