module dht11_data_trans(
	sys_clk,
	rst_n,
	Data_ASCII,
	dht11);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input rst_n;
	output [167:0] Data_ASCII;
	inout dht11;

	wire sys_clk;
	wire rst_n;
	wire [167:0] Data_ASCII;
	wire dht11;
	wire [7:0] DHT115_tempH;
	wire [7:0] DHT115_tempL;
	wire [7:0] DHT115_humidityH;
	wire [7:0] DHT115_humidityL;

	//----Code starts here: integrated by Robei-----
	assign Data_ASCII={24'h53443a,SD_int_data_valid[23:0],8'h2e,SD_float_data_valid[23:0],8'h20,24'h57443a,WD_int_data_valid[23:0],8'h2e,WD_float_data_valid[23:0]};
	wire [23:0]SD_int_data_valid;
	wire [23:0]SD_float_data_valid;
	wire [23:0]WD_int_data_valid;
	wire [23:0]WD_float_data_valid;
	
	
	wire dht11_done;
	reg  dht11_req;
	
	localparam S_DELAY	=	'd55_000_000;
	reg[35:0]	delay;
	always@(posedge sys_clk or negedge rst_n)
	begin
		if(rst_n == 1'b0)
			delay <= 'd0;
		else if(dht11_done == 1'b1)
			delay <= 'd0;
		else if(delay == S_DELAY)
			delay <= delay;
		else 
			delay <= delay + 1'b1;
	end
	
	always@(posedge sys_clk or negedge rst_n)
	begin
		if(rst_n == 1'b0)	
			dht11_req <= 1'b0;
		else if(delay == S_DELAY)
			dht11_req <= 1'b1;
		else
			dht11_req <= 1'b0;
	
	
	end
	//---Module instantiation---
	hex2ascii SD_int(
		.din(DHT115_tempH),
		.clk(sys_clk),
		.rst(rst_n),
		.data_valid(SD_int_data_valid));

	hex2ascii WD_int(
		.din(DHT115_humidityH),
		.clk(sys_clk),
		.rst(rst_n),
		.data_valid(WD_int_data_valid));

	hex2ascii SD_float(
		.din(DHT115_tempL),
		.clk(sys_clk),
		.rst(rst_n),
		.data_valid(SD_float_data_valid));

	hex2ascii WD_float(
		.din(DHT115_humidityL),
		.clk(sys_clk),
		.rst(rst_n),
		.data_valid(WD_float_data_valid));

	DHT11 DHT115(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.dht11_req(dht11_req),
		.dht11_done(dht11_done),
		.tempH(DHT115_tempH),
		.tempL(DHT115_tempL),
		.humidityH(DHT115_humidityH),
		.humidityL(DHT115_humidityL),
		.dht11(dht11));

endmodule    //dht11_data_trans

