module iic2(
	sys_clk,
	rst_n,
	IICSlave,
	IICWriteReq,
	IICWriteData,
	IICReadReq,
	IICSCL,
	IICWriteDone,
	IICReadDone,
	IICReadData,
	IICSDA);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input rst_n;
	input [15:0] IICSlave;
	input IICWriteReq;
	input [7:0] IICWriteData;
	input IICReadReq;
	output IICSCL;
	output IICWriteDone;
	output IICReadDone;
	output [7:0] IICReadData;
	inout IICSDA;

	wire sys_clk;
	wire rst_n;
	wire [15:0] IICSlave;
	wire IICWriteReq;
	wire [7:0] IICWriteData;
	wire IICReadReq;
	wire IICSCL;
	wire IICWriteDone;
	wire IICReadDone;
	wire [7:0] IICReadData;
	wire IICSDA;

	//----Code starts here: integrated by Robei-----
	/*IIC ״̬*/
	localparam IIC_IDLE       =   6'b000_001;  /*̬*/
	localparam IIC_START      =   6'b000_010;  /*ʼ̬*/
	localparam IIC_WRDATA     =   6'b000_100;  /*д̬*/
	localparam IIC_RDDATA     =   6'b001_000;  /*̬*/
	localparam IIC_ACK        =   6'b010_000;  /*Ӧ̬*/
	localparam IIC_STOP       =   6'b100_000;  /*ֹ̬ͣ*/
	
	
	
	localparam  IIC_Pre       =   'd100;     /*iiCƵ*/
	    
	reg[5:0]   state , next_state;
	reg[21:0]  IICCnt;              /*IIC*/
	reg[3:0]   IICBitCnt;           /*IICݷ͸*/
	reg[1:0]   IICACKStopCnt;       /*IIC ack stopӦ*/
	reg[2:0]   IICSendBytes;        /*IIC ֽڼ*/ 
	
	
	reg[15:0]   IICSlaveReg;           /*ӻַ+Ĵ*/
	reg[7:0]   IICReadDataReg;         /*ȡ*/
	
	
	reg 	IICWriteReqReg;
	
	reg   iictx;     /*iic*/
	reg   iicCLK;    /*iicʱź*/
	
	assign IICSDA = (state == IIC_RDDATA || (state == IIC_ACK)) ? 1'bz : iictx;  /*iicΪݻӦʱΪ̬*/
	assign IICSCL =  iicCLK;
	
	assign IICReadData = IICReadDataReg;
	
	assign IICReadDone  = (state != next_state && state == IIC_STOP) ? 1'b1 : 1'b0;
	assign IICWriteDone = (state != next_state && state == IIC_STOP) ? 1'b1 : 1'b0;
	
	
	
	always@(posedge sys_clk or negedge rst_n)
	begin
		if(rst_n == 1'b0)
			IICWriteReqReg <= 1'b0;
		else if(IICWriteDone == 1'b1)
			IICWriteReqReg <= 1'b0;
		else if(IICWriteReq == 1'b1)
		   IICWriteReqReg <= 1'b1;
		else
			IICWriteReqReg <= IICWriteReqReg;
	
	end
	
	always @(posedge sys_clk or negedge rst_n) 
	begin
	    if(rst_n == 1'b0)
	        state <= IIC_IDLE;
	    else
	        state <= next_state;   
	end
	
	/*״̬*/
	always @(*)
	begin
	    case(state)
	    IIC_IDLE: 
	        if(IICWriteReq == 1'b1 || IICReadReq == 1'b1)
	            next_state <= IIC_START;
	        else
	            next_state <= IIC_IDLE;
	    IIC_START:
	        if(IICCnt == (IIC_Pre * 'd2))
	            next_state <= IIC_WRDATA;
	        else
	            next_state <= IIC_START;
	    IIC_WRDATA:
	        if(IICBitCnt == 'd8 /*&& IICCnt == IIC_Pre /4 */&& iicCLK == 1'b0)
	            next_state <= IIC_ACK;
	        else
	            next_state <= IIC_WRDATA;
	    IIC_RDDATA:
	        if(IICBitCnt == 'd8 && IICCnt == IIC_Pre /4 && iicCLK == 1'b0)
	            next_state <= IIC_ACK;
	        else
	            next_state <= IIC_RDDATA;
	    IIC_ACK:
	        if(IICACKStopCnt == 'd1 /*&& IICCnt == IIC_Pre /4 */&& iicCLK == 1'b0)
	            if(IICSendBytes == 'd2) 
	                if(/*IICWriteReq*/IICWriteReqReg == 1'b1)             /*ֽڷɣֹ̬ͣ*/
	                    next_state <= IIC_STOP;
	                else 
	                    next_state <= IIC_RDDATA;
	            else if(IICSendBytes == 'd2 && IICReadReq == 1'b1)
	                next_state <= IIC_START;
	            else if(IICSendBytes == 'd4)
	                next_state <= IIC_STOP;
	            else
	                next_state <= IIC_WRDATA;
	        else
	            next_state <= IIC_ACK;
	    IIC_STOP:
	        if(IICACKStopCnt == 'd1 && IICCnt == IIC_Pre/4 && iicCLK == 1'b1)
	            next_state <= IIC_IDLE;
	        else
	            next_state <= IIC_STOP;
	    default:  next_state <= IIC_IDLE;
	    endcase
	end
	
	
	
	/*IIC ֽڼ*/
	always@(posedge sys_clk or negedge rst_n)
	begin
	    if(rst_n == 1'b0)
	        IICSendBytes <= 'd0;
	    else if(state == IIC_IDLE)
	        IICSendBytes <= 'd0;
	    else if(state == IIC_ACK)
	        if(next_state != state)
	            IICSendBytes <= IICSendBytes + 1'b1;
	        else
	            IICSendBytes <= IICSendBytes;
	    else
	        IICSendBytes <= IICSendBytes;
	
	end
	
	/*IICƵ*/
	always@(posedge sys_clk or negedge rst_n)
	begin
	    if(rst_n == 1'b0)
	        IICCnt <= 'd0;
	    else if(IICCnt == IIC_Pre && state != IIC_START)
	        IICCnt <= 'd0;
	    else if(IICCnt == (IIC_Pre *'d2) && state != IIC_START)
	        IICCnt <= 'd0;
	    else if(state != next_state)
	        IICCnt <= 'd0;
	    else if(state == IIC_START)
	        IICCnt <= IICCnt + 1'b1;
	    else if(state == IIC_WRDATA )
	        IICCnt <= IICCnt + 1'b1;
	    else if(state == IIC_RDDATA)
	        IICCnt <= IICCnt + 1'b1;
	    else if(state == IIC_ACK)
	        IICCnt <= IICCnt + 1'b1;
	    else if(state == IIC_STOP)
	        IICCnt <= IICCnt + 1'b1;
	end
	
	/*IICbit*/
	always@(posedge sys_clk or negedge rst_n)
	begin
	    if(rst_n == 1'b0)
	        IICBitCnt <= 'd0;
	    else if(state == IIC_IDLE || state == IIC_ACK)
	        IICBitCnt <= 'd0;
	    else if(state == IIC_WRDATA && IICCnt == (IIC_Pre /2))
	        if(iicCLK == 1'b1)
	            IICBitCnt <= IICBitCnt + 1'b1;
	        else
	            IICBitCnt <= IICBitCnt;
	    else if(state == IIC_RDDATA && IICCnt == (IIC_Pre /2))
	        if(iicCLK == 1'b1)
	            IICBitCnt <= IICBitCnt + 1'b1;
	        else
	            IICBitCnt <= IICBitCnt;
	    else
	        IICBitCnt <= IICBitCnt;
	end
	
	
	/*IIC ack stopӦ*/
	always@(posedge sys_clk or negedge rst_n)
	begin
	    if(rst_n == 1'b0)
	        IICACKStopCnt <= 'd0;
	    else if(state != next_state)
	        IICACKStopCnt <= 'd0;
	    else if((state == IIC_ACK || state == IIC_STOP) && IICCnt == (IIC_Pre /2))
	        if(iicCLK == 1'b1)
	            IICACKStopCnt <= IICACKStopCnt + 1'b1;
	        else
	            IICACKStopCnt <= IICACKStopCnt;
	    else if(state == IIC_ACK || state == IIC_STOP)
	        IICACKStopCnt <= IICACKStopCnt;
	    else
	        IICACKStopCnt <= 'd0;
	end
	
	/*IICӻϢ*/
	always@(posedge sys_clk or negedge rst_n)
	begin
	    if(rst_n == 1'b0)
	        IICSlaveReg <= 'd0;
	    else if((IICWriteReq == 1'b1 || IICReadReq == 1'b1) && state == IIC_IDLE)  /*ʱϢ*/
	        IICSlaveReg <= IICSlave;
	    else if(state == IIC_ACK && state != next_state)   /*ÿһֽڣ͵ݣʼշ͵ǵ8λ*/
	        if(IICSendBytes == 'd2)
	            IICSlaveReg <= {IICSlaveReg[7:0],IICSlaveReg[15:8]} + 1'b1;
	        else
	            IICSlaveReg <= {IICSlaveReg[7:0],IICSlaveReg[15:8]};
	    else
	        IICSlaveReg <= IICSlaveReg;
	end
	
	
	/*IIC ʱӿ*/
	always@(posedge sys_clk or negedge rst_n)
	begin
	    if(rst_n == 1'b0)
	        iicCLK <= 1'b1;
	    else if(state == IIC_START && IICCnt == (IIC_Pre*2))      /*ʼʱʱ*/
	        iicCLK <= 1'b0;
	    else if(state == IIC_START && IICCnt > IIC_Pre)
	        iicCLK <= 1'b1;
	    else if(state == IIC_START && IICCnt == IIC_Pre)
	        iicCLK <= iicCLK;
	    else if(state == IIC_WRDATA && IICCnt == IIC_Pre)     /*ݣȡʱ*/
	        iicCLK <= ~iicCLK;
	    else if(state == IIC_RDDATA && IICCnt == IIC_Pre)     /*ݣȡʱ*/
	        iicCLK <= ~iicCLK;
	    else if(state == IIC_ACK && IICCnt == IIC_Pre)
	        iicCLK <= ~iicCLK;
	    else if(state == IIC_STOP && IICCnt == IIC_Pre)  /*ֹ̬ͣʱIICCntʱֱiicCLK*/
	        iicCLK <= 1'b1;
	end
	
	
	/*iic Ϳ*/
	always@(posedge sys_clk or negedge rst_n)
	begin
	    if(rst_n == 1'b0)   
	        iictx <= 1'b1;
	    else if(state == IIC_START && IICCnt == (IIC_Pre/2))      /*ʼiic*/
	        iictx <= 1'b0;
	    else if(state == IIC_START && IICCnt == IIC_Pre/4)      /*ʼiic*/
	        iictx <= 1'b1;
	    else if(state == IIC_WRDATA && IICCnt == IIC_Pre / 2)     /*iic*/
	        if(iicCLK == 1'b0 && IICSendBytes == 'd2 && (IICWriteReq == 1'b1 || IICWriteReqReg == 1'b1))
	            iictx <= IICWriteData['d7-IICBitCnt];
	        else if(iicCLK == 1'b0)
	            iictx <= IICSlaveReg['d7-IICBitCnt];
	        else
	            iictx <= iictx;
	    else if(state == IIC_ACK)
	        iictx <= 1'b0;
	
	    else if(state == IIC_STOP && IICCnt == (IIC_Pre))
	        if(iicCLK == 1'b1)
	            iictx <= 1'b1;
	        else
	            iictx <= iictx;
	    else if(state == IIC_IDLE)
	        iictx <= 1'b1;
	end
	
	
	/*iic ȡݿ*/
	always@(posedge sys_clk or negedge rst_n)
	begin
	    if(rst_n == 1'b0)
	        IICReadDataReg <= 'd0;
	    else if(state == IIC_RDDATA && IICCnt == IIC_Pre / 2)
	        if(iicCLK == 1'b1)
	            IICReadDataReg <= {IICReadDataReg[6:0],IICSDA};
	        else
	            IICReadDataReg <= IICReadDataReg;
	    else
	        IICReadDataReg <= IICReadDataReg;
	end
	
	
	
endmodule    //iic2

