module lora_drive_pro(
	clk,
	rst,
	dht11_data,
	tx_data,
	trans_en,
	tx_flag,
	detect);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst;
	input [167:0] dht11_data;
	output [7:0] tx_data;
	output trans_en;
	input tx_flag;
	input detect;

	wire clk;
	wire rst;
	wire [167:0] dht11_data;
	wire [7:0] tx_data;
	reg trans_en;
	wire tx_flag;
	wire detect;

	//----Code starts here: integrated by Robei-----
	parameter CNT_1s=33_333_333;
	parameter CNT_trans=17000;
	parameter BYTE_MAX=60;//(48+184+200+16+32)/8,127ֽ
	//parameter CNT_EN=CNT_trans*BYTE_MAX*2;
	//test//
	//parameter BYTE_MAX=5;//(88+72)/8
	(*mark_debug="true"*)reg EN;
	
	wire	EN_flag;
	reg		EN_d0;
	reg		EN_d1;
	
	wire	trans_flag;
	reg		trans_d0;
	reg		trans_d1;
	
	reg [15:0]  detect_value;//Ƿȫؼ S:ȫ W:
	always@(posedge clk or negedge rst)
	begin
	if(!rst)
		detect_value<=16'h53;//S
	else
	begin
		if(detect==1)
			detect_value<=16'h57;//W
		else
			detect_value<=16'h53;
	end
	end
	reg	[16:0]cnt_trans;//̶ֵ
	reg [24:0] cnt_en;
	(*mark_debug="true"*)reg	[6:0]	cnt_byte;//tx_flag½أ127
	reg [7:0]	ShiftReg;
	
	reg [BYTE_MAX*8-1:0] data_to_trans;// data_to_trans={MQ_data,8'h20,dht11_data,8'h20,gps_data,16'h0d0a,8'h20,detect_value};
	
	//tx_flag½
		                                                
	always@( negedge tx_flag or negedge rst)
		if(!rst)
			cnt_byte<=0;
		else if(cnt_byte==BYTE_MAX-1)
			cnt_byte<=0;
		else
			cnt_byte<=cnt_byte+1;
	
	
	always@(posedge clk or negedge rst)
	if(!rst)begin
		cnt_en<=0;
		EN<=0;end
	else if(cnt_en==CNT_1s)begin
		cnt_en<=0;
		EN<=~EN;
	end
	else if(cnt_byte==BYTE_MAX-1)begin
		cnt_en<=0;
		EN<=0;
	end
	else begin
		cnt_en<=cnt_en+1;
		EN<=EN;
	end
		
	//trans_en
	always@(posedge clk or negedge  rst)
		if(!rst)begin
			cnt_trans<=0;
			trans_en<=0;
		end
		else if(EN)begin
			if(cnt_byte<BYTE_MAX)begin
				if(cnt_trans==CNT_trans)
				begin
					cnt_trans<=0;
					trans_en<=~trans_en;
				end
				else
				begin
					cnt_trans<=cnt_trans+1;
					trans_en<=trans_en;
				end
			end
			else begin
				cnt_trans<=0;
				trans_en<=0;
			end
		end
		else begin
			cnt_trans<=0;
			trans_en<=0;
		end
	
	//ENأõһʱڵź
	assign EN_flag = (~EN_d1) & EN_d0;
		                                                 
	//ԷʹźENӳʱ
	always @(posedge clk or negedge rst) begin         
		if (!rst) begin
			EN_d0 <= 1'b0;                                  
			EN_d1 <= 1'b0;
		end                                                      
		else begin                                               
			EN_d0 <= EN;                               
			EN_d1 <=	EN_d0;                            
		end
	end
	
	//trans_enأõһʱڵź
	assign trans_flag = (~trans_d1) & trans_d0;
		                                                 
	//ԷʹźENӳʱ
	always @(posedge clk or negedge rst) begin         
		if (!rst) begin
			trans_d0 <= 1'b0;                                  
			trans_d1 <= 1'b0;
		end                                                      
		else begin                                               
			trans_d0 <= trans_en;                               
			trans_d1 <= trans_d0;                            
		end
	end
	
	always@(posedge clk or negedge rst)begin
		if(!rst)begin
				ShiftReg<=data_to_trans[BYTE_MAX*8-1:BYTE_MAX*8-8];
				data_to_trans<=0;
		end
		else if(EN_flag)begin
				data_to_trans={dht11_data,8'h20,detect_value,16'h0d0a};
		end
		else if(trans_flag)begin
				ShiftReg<=data_to_trans[BYTE_MAX*8-1:BYTE_MAX*8-8];
				data_to_trans<=data_to_trans<<8;
		end
	end
	assign tx_data=ShiftReg;
	
	/*
	always@(posedge clk or negedge rst)begin
	if(!rst)
		tx_data<=0;
	else begin
		case(cnt_byte)
		4'd0:tx_data<=data_to_trans[103:96];
		4'd1:tx_data<=data_to_trans[95:88];
		4'd2:tx_data<=data_to_trans[87:80];
		4'd3:tx_data<=data_to_trans[79:72];
		4'd4:tx_data<=data_to_trans[71:64];
		4'd5:tx_data<=data_to_trans[63:56];
		4'd6:tx_data<=data_to_trans[55:48];
		4'd7:tx_data<=data_to_trans[47:40];
		4'd8:tx_data<=data_to_trans[39:32];
		4'd9:tx_data<=data_to_trans[31:24];
		4'd10:tx_data<=data_to_trans[23:16];
		4'd11:tx_data<=data_to_trans[15:8];
		4'd12:tx_data<=data_to_trans[7:0];
		endcase
	end
	end
	*/
	
endmodule    //lora_drive_pro

