module top_car(
	clk,
	rst_n,
	scl,
	sda,
	echo_l,
	trig_l,
	trig_r,
	echo_r,
	trig_f1,
	echo_f1,
	yuyin);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	output scl;
	inout sda;
	input echo_l;
	output trig_l;
	output trig_r;
	input echo_r;
	output trig_f1;
	input echo_f1;
	input yuyin;

	wire clk;
	wire rst_n;
	wire scl;
	wire sda;
	wire echo_l;
	wire trig_l;
	wire trig_r;
	wire echo_r;
	wire trig_f1;
	wire echo_f1;
	wire yuyin;
	wire car_control6_i2c_exec;
	wire car_control6_i2c_rh_wl;
	wire [15:0] car_control6_i2c_addr;
	wire [7:0] car_control6_i2c_data_w;
	wire IIC1_dri_clk;
	wire [7:0] IIC1_i2c_data_r;
	wire IIC1_i2c_done;
	wire IIC1_i2c_ack;
	wire ultrasonic_right5_out;
	wire ultrasonic_left4_out;
	wire ultrasonic_front16_out;

	//----Code starts here: integrated by Robei-----
	//parameter define
	parameter    SLAVE_ADDR = 7'b011_0100     ; //ַ(SLAVE_ADDR)
	parameter    BIT_CTRL   = 1'b0           ; //ֵַλƲ(16b/8b)
	parameter    CLK_FREQ   = 26'd50_000_000 ; //i2c_driģʱƵ(CLK_FREQ)
	parameter    I2C_FREQ   = 18'd250_000    ; //I2CSCLʱƵ
	parameter    L_TIME     = 17'd125_000    ; //led˸ʱ
	
	
	
	//---Module instantiation---
	IIC IIC1(
		.clk(clk),
		.rst_n(rst_n),
		.i2c_exec(car_control6_i2c_exec),
		.bit_ctrl(BIT_CTRL),
		.i2c_rh_wl(car_control6_i2c_rh_wl),
		.i2c_addr(car_control6_i2c_addr),
		.i2c_data_w(car_control6_i2c_data_w),
		.i2c_data_r(IIC1_i2c_data_r),
		.i2c_done(IIC1_i2c_done),
		.i2c_ack(IIC1_i2c_ack),
		.scl(scl),
		.dri_clk(IIC1_dri_clk),
		.sda(sda));

	ultrasonic_left ultrasonic_left4(
		.clk(clk),
		.rst_n(rst_n),
		.echo(echo_l),
		.trig(trig_l),
		.out(ultrasonic_left4_out));

	ultrasonic_right ultrasonic_right5(
		.clk(clk),
		.rst_n(rst_n),
		.echo(echo_r),
		.trig(trig_r),
		.out(ultrasonic_right5_out));

	ultrasonic_front1 ultrasonic_front16(
		.clk(clk),
		.rst_n(rst_n),
		.echo(echo_f1),
		.trig(trig_f1),
		.out(ultrasonic_front16_out));

	car_control car_control6(
		.clk(IIC1_dri_clk),
		.rst_n(rst_n),
		.i2c_data_r(IIC1_i2c_data_r),
		.i2c_done(IIC1_i2c_done),
		.i2c_ack(IIC1_i2c_ack),
		.i2c_rh_wl(car_control6_i2c_rh_wl),
		.i2c_exec(car_control6_i2c_exec),
		.i2c_addr(car_control6_i2c_addr),
		.i2c_data_w(car_control6_i2c_data_w),
		.f1(ultrasonic_front16_out),
		.l(ultrasonic_left4_out),
		.r(ultrasonic_right5_out),
		.yuyin(yuyin));

endmodule    //top_car

