module top_dht11_oled(
	sys_clk,
	rst_n,
	OLED_SCL,
	OLED_SDA,
	dht11);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input rst_n;
	output OLED_SCL;
	inout OLED_SDA;
	inout dht11;

	wire sys_clk;
	wire rst_n;
	wire OLED_SCL;
	wire OLED_SDA;
	wire dht11;

	//----Code starts here: integrated by Robei-----
	
	
	
	wire dht11_done;
	reg  dht11_req;
	wire[7:0]  tempH;
	wire[7:0]  tempL;	
	wire[7:0]  humidityH;
	wire[7:0]  humidityL;
	
	localparam S_DELAY	=	'd55_000_000;
	reg[35:0]	delay;
	
	always@(posedge sys_clk or negedge rst_n)
	begin
		if(rst_n == 1'b0)
			delay <= 'd0;
		else if(dht11_done == 1'b1)
			delay <= 'd0;
		else if(delay == S_DELAY)
			delay <= delay;
		else 
			delay <= delay + 1'b1;
	end
	
	always@(posedge sys_clk or negedge rst_n)
	begin
		if(rst_n == 1'b0)	
			dht11_req <= 1'b0;
		else if(delay == S_DELAY)
			dht11_req <= 1'b1;
		else
			dht11_req <= 1'b0;
	
	
	end
	//---Module instantiation---
	OLED_Top OLED_Top1(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.dht11_done(dht11_done),
		.tempH(tempH),
		.tempL(tempL),
		.humidityH(humidityH),
		.humidityL(humidityL),
		.OLED_SCL(OLED_SCL),
		.OLED_SDA(OLED_SDA));

	DHT11 DHT112(
		.sys_clk(sys_clk),
		.rst_n(rst_n),
		.dht11_req(dht11_req),
		.dht11_done(dht11_done),
		.tempH(tempH),
		.tempL(tempL),
		.humidityH(humidityH),
		.humidityL(humidityL),
		.dht11(dht11));

endmodule    //top_dht11_oled

