module ultrasonic_left(
	clk,
	rst_n,
	echo,
	trig,
	out);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input echo;
	output trig;
	output out;

	wire clk;
	wire rst_n;
	wire echo;
	wire trig;
	wire out;

	//----Code starts here: integrated by Robei-----
	parameter idle=3'b001,     //״̬
	             s0=3'b010,     //ƻźŵʱ
	             s1=3'b100;     //  תֵ
	///״̬   
	parameter ms_100ms=750+(50_000*100);    //15us   10usĸߵƽ      100ms   50_000*100
	reg [23:0]  trig_cnt;     //Ƽ
	reg [2:0]   cur_state;    //״̬Ĵ
	reg [2:0]   next_state;
	reg [24:0]  echo_cnt    ;  //źŸߵƽĳʱ
	reg [24:0]  echo_cnt_reg;  //źŸߵƽʱ
	wire [24:0]  dis;           //ľ
	always@(posedge clk)begin
	if(!rst_n)
	    trig_cnt<=0;
	else if(trig_cnt==ms_100ms-1)      //ǵֵʱ  
	    trig_cnt<=0;
	else 
	    trig_cnt<=trig_cnt+1;
	end
	 
	assign trig=(trig_cnt>0 && trig_cnt<750)?1:0;
	//ʹź
	always@(posedge clk)begin
	if(!rst_n)
	    cur_state<=idle;
	else
	    cur_state<=next_state;
	end
	 
	always@(*)begin
	    case(cur_state)
	    idle:begin
	         if(echo==1)
	            next_state=s0;
	         else
	            next_state=idle;
	    end
	       s0:begin
	          if(echo==0)
	            next_state=s1;
	          else
	            next_state=s0;
	       end
	       s1:next_state=idle;    //1clk
	    default:next_state=idle;
	    endcase
	end
	//״̬ת
	always@(posedge clk)begin
	if(!rst_n)
	    begin
	    echo_cnt    <=0;
	    echo_cnt_reg<=0;
	    end
	else
	    case(cur_state)
	    idle:begin
	         echo_cnt    <=0;
	         echo_cnt_reg<=echo_cnt_reg;
	    end
	    s0  :begin
	         echo_cnt<=echo_cnt+1;     //
	         echo_cnt_reg<=echo_cnt_reg;
	    end
	    s1  :begin
	         echo_cnt    <=0;         //100  
	         echo_cnt_reg<=echo_cnt;   //תֵ
	    end
	    default:begin
	            echo_cnt    <=0;
	            echo_cnt_reg<=0;
	            end
	    endcase
	end
	 
	assign dis=(echo_cnt_reg*20)/1000/58;   //
	//assign out=(dis>0 && dis<20)?1:0;      ///0<dis<20cm
	assign out=(dis>0 && dis<15)?1:0; 
	
	
	
	
	
	
	
	
	
	
	
	
	
	
endmodule    //ultrasonic_left

